---
title: Use a source map
slug: Tools/Debugger/How_to/Use_a_source_map
---
<div>{{ToolsSidebar}}</div>

<p>The JavaScript sources executed by the browser are often transformed in some way from the original sources created by a developer. For example:</p>

<ul>
 <li>sources are often combined and <a href="https://en.wikipedia.org/wiki/Minification_(programming)">minified</a> to make delivering them from the server more efficient.</li>
 <li>JavaScript running in a page is often machine-generated, as when compiled from a language like <a href="http://coffeescript.org/">CoffeeScript</a> or <a href="http://www.typescriptlang.org/">TypeScript</a>.</li>
</ul>

<p>In these situations, it's much easier to debug the original source, rather than the source in the transformed state that the browser has downloaded. A <a href="http://www.html5rocks.com/en/tutorials/developertools/sourcemaps/">source map</a> is a file that maps from the transformed source to the original source, enabling the browser to reconstruct the original source and present the reconstructed original in the debugger.</p>

<p>To enable the debugger to work with a source map, you must:</p>

<ul>
 <li>generate the source map</li>
 <li>include a comment in the transformed file, that points to the source map. The comment's syntax is like this:</li>
</ul>

<pre class="brush: js"><code>//# sourceMappingURL=http://example.com/path/to/your/sourcemap.map</code></pre>

<p>{{EmbedYouTube("Fqd15gHC4Pg")}}</p>

<p>In the video above we load <a href="https://mdn.github.io/devtools-examples/sourcemaps-in-console/index.html">https://mdn.github.io/devtools-examples/sourcemaps-in-console/index.html</a>. This page loads a source called "main.js" that was originally written in CoffeeScript and compiled to JavaScript. The compiled source contains a comment like this, that points to a source map:</p>

<pre class="brush: js"><code>//# sourceMappingURL=main.js.map</code></pre>

<p>In the Debugger's <a href="/en-US/docs/Tools/Debugger/UI_Tour#Source_list_pane">source list pane</a>, the original CoffeeScript source now appears as "main.coffee", and we can debug it just like any other source.</p>
